
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotFoundException;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author jacob
 */
public class SettingsManager {

    private DTMFDial dialer;
    private static final String TIMINGS = "TIMING";


    public SettingsManager(DTMFDial dialer) {
        this.dialer = dialer;
    }

    private void defaultInit() {
    }

    private byte[] persist() throws IOException {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        DataOutputStream os = new DataOutputStream(baos);
        os.writeInt(dialer.dtmfDuration);
        os.writeInt(dialer.dtmfPause);
        os.writeUTF(dialer.emptyPrefix);
        os.writeUTF(dialer.replacePlus);
        os.close();
        return baos.toByteArray();
    }

    private void read(byte[] bytes) throws IOException {
        DataInputStream dis = new DataInputStream(new ByteArrayInputStream(bytes));
        dialer.dtmfDuration = dis.readInt();
        dialer.dtmfPause = dis.readInt();
        dialer.emptyPrefix = dis.readUTF();
                dialer.replacePlus = dis.readUTF();
        dis.close();

    }

    public void readSettings() {

        try {
            RecordStore rs = RecordStore.openRecordStore(TIMINGS, false);

            if (rs.getNumRecords() == 0) {
                rs.closeRecordStore();
                defaultInit();
                return;
            }

            byte[] data = rs.getRecord(1);
            read(data);
            rs.closeRecordStore();


        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (RecordStoreNotFoundException e) {
            defaultInit();
        } catch (RecordStoreException ex) {
            ex.printStackTrace();
        }

    }

    public void writeSettings() {

        RecordStore rs = null;
        try {

            rs = RecordStore.openRecordStore(TIMINGS, true);
            byte[] data = persist();
            if (rs.getNumRecords() == 0) {
                rs.addRecord(data, 0, data.length);
            } else {
                rs.setRecord(1, data, 0, data.length);
            }
            rs.closeRecordStore();
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (RecordStoreException ex) {
            ex.printStackTrace();
        }
    }
}
